﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MVVMCurrentSelectedRecordCase
{
    class ViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<FoodClass> Data { get; set; }
        public ObservableCollection<FoodClass> Selected { get; set; }

        public string[] foodtype = { "Seafood", "Vegetables", "Fruit", "Meat", "Various Munchies" };
        public int[] productID = { 1234, 2345, 3456, 4567, 5678 };
        public int[] unitsIn = { 12, 23, 34, 45, 56 };
        public int[] unitsOn = { 11, 22, 33, 44, 55 };

        public ViewModel()
        {
            CreateDataSource();
            Selected = new ObservableCollection<FoodClass>();
        }

        public void CreateDataSource()
        {
            Data = new ObservableCollection<FoodClass>();
            for (int i = 0; i < foodtype.Length; i++)
            {
                Data.Add(new FoodClass
                {
                    ProductID = productID[i],
                    FoodType = foodtype[i],
                    UnitsOnOrder = unitsOn[i],
                    UnitsInStock = unitsIn[i],
                     
                });
                SelectedFoods = Selected;
            }
        }

        public ObservableCollection<FoodClass> SelectedFoods
        {
            get { return this.Selected; }
            set
            {
                if (value != this.Selected)
                {
                    this.Selected = value;
                    OnPropertyChanged("SelectedFoods");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class FoodClass : INotifyPropertyChanged
    {
        private string type;
        private int id;
        private int unitsIn;
        private int unitsOn;

        public string FoodType
        {
            get { return type; }
            set
            {
                if (type != value)
                {
                    type = value;
                    OnPropertyChanged("FoodType");
                }
            }
        }

        public int ProductID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ProductID");
                }
            }
        }

        public int UnitsOnOrder
        {
            get { return unitsOn; }
            set
            {
                if (unitsOn != value)
                {
                    unitsOn = value;
                    OnPropertyChanged("UnitsOnOrder");
                }
            }
        }

        public int UnitsInStock
        {
            get { return unitsIn; }
            set
            {
                if (unitsIn != value)
                {
                    unitsIn = value;
                    OnPropertyChanged("UnitsInStock");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
